import { InstancedInterleavedBuffer, Material, Object3D, WebGLRenderer } from 'three';
import SpeckleLineMaterial from '../materials/SpeckleLineMaterial';
import { NodeRenderView } from '../tree/NodeRenderView';
import { Batch, BatchUpdateRange, GeometryType } from './Batch';
export default class LineBatch implements Batch {
    id: string;
    subtreeId: string;
    renderViews: NodeRenderView[];
    private geometry;
    batchMaterial: SpeckleLineMaterial;
    private mesh;
    colorBuffer: InstancedInterleavedBuffer;
    private insertedRanges;
    private static readonly vector4Buffer;
    get bounds(): import("three").Box3;
    constructor(id: string, subtreeId: string, renderViews: NodeRenderView[]);
    updateBatchObjects(): void;
    get renderObject(): Object3D;
    get geometryType(): GeometryType;
    getCount(): number;
    setBatchMaterial(material: SpeckleLineMaterial): void;
    onUpdate(deltaTime: number): void;
    onRender(renderer: WebGLRenderer): void;
    setVisibleRange(...ranges: BatchUpdateRange[]): void;
    getVisibleRange(): BatchUpdateRange;
    setDrawRanges(...ranges: BatchUpdateRange[]): void;
    insertDrawRanges(...ranges: BatchUpdateRange[]): void;
    removeDrawRanges(id: string): void;
    autoFillDrawRanges(): void;
    resetDrawRanges(): void;
    buildBatch(): void;
    getRenderView(index: number): NodeRenderView;
    getMaterialAtIndex(index: number): Material;
    private makeLineGeometry;
    private makeLineGeometryTriangle;
    private updateColorBuffer;
    purge(): void;
}
